﻿<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:r="http://schemas.openxmlformats.org/officeDocument/2006/relationships"
    xmlns:msxsl="urn:schemas-microsoft-com:xslt" exclude-result-prefixes="msxsl">
  <xsl:output method="xml" indent="yes"/>
  <xsl:template match="testreport">
    <xsl:variable name="colmn" select="abcdefg"/>
    <worksheet xmlns="http://schemas.openxmlformats.org/spreadsheetml/2006/main" xmlns:r="http://schemas.openxmlformats.org/officeDocument/2006/relationships" xmlns:xdr="http://schemas.openxmlformats.org/drawingml/2006/spreadsheetDrawing" xmlns:x14="http://schemas.microsoft.com/office/spreadsheetml/2009/9/main" xmlns:mc="http://schemas.openxmlformats.org/markup-compatibility/2006" mc:Ignorable="x14ac" xmlns:x14ac="http://schemas.microsoft.com/office/spreadsheetml/2009/9/ac">
      <dimension ref="B1:G33"/>
      <sheetViews>
        <sheetView tabSelected="1" workbookViewId="0">
          <selection activeCell="H23" sqref="H23"/>
        </sheetView>
      </sheetViews>
      <sheetFormatPr baseColWidth="10" defaultRowHeight="15" outlineLevelRow="2"/>
      <cols>
        <col min="2" max="2" width="4.1640625" customWidth="1"/>
        <col min="3" max="3" width="43.33203125" bestFit="1" customWidth="1"/>
        <col min="4" max="4" width="16.83203125" bestFit="1" customWidth="1"/>
        <col min="5" max="5" width="20.5" bestFit="1" customWidth="1"/>
        <col min="6" max="6" width="12.1640625" bestFit="1" customWidth="1"/>
      </cols>
      <xsl:element name="sheetData">
        <xsl:variable name="Differences_per_Screen">
          <xsl:value-of select="count(//stateDifference//window[not(./@screenId = ./preceding::stateDifference//window/@screenId)])"/>
        </xsl:variable>
        <row r="1" spans="3:7" s="3" customFormat="1" ht="67" customHeight="1"/>
        <row></row>
        <row r="2" spans="3:7" ht="18">
          <c r="C2" s="2" t="inlineStr">
            <is>
              <t>Differences per Screen</t>
            </is>
          </c>
          <c r="E2" t="inlineStr">
            <is>
              <t>Tests:</t>
            </is>
          </c>
          <c r="F2" t="inlineStr">
            <is>
              <t>Components:</t>
            </is>
          </c>
        </row>
        <xsl:for-each select="//stateDifference//window[not(./@screenId = ./preceding::stateDifference//window/@screenId)]">
          <xsl:sort select="@screenId" />
          <xsl:variable name="window" select="."/>
          <row spans="3:7" outlineLevel="1">
            <c r="C" s="2" t="inlineStr">
              <is>
                <t>
                  screen<xsl:text disable-output-escaping="yes"> "</xsl:text>
                  <xsl:value-of select="@screen"/><xsl:text disable-output-escaping="yes">"</xsl:text>
                </t>
              </is>
            </c>
            <c r="D">
              <xsl:choose>
                <xsl:when test="img[@type='expected']">
                  <is>
                    <t>
                      <!-- <xsl:value-of select="img[@type='expected']/@file" /> -->
                    </t>
                  </is>
                </xsl:when>
                <xsl:otherwise>
                  <is>
                    <t>
                      <xsl:value-of select="@title" />
                    </t>
                  </is>
                </xsl:otherwise>
              </xsl:choose>
            </c>
            <c r="E" s="2" t="inlineStr">
              <xsl:for-each select="//test[.//stateDifference//window/@screenId = $window/@screenId]">
                <is>
                  <t>
                    <xsl:value-of select="@name"/>
                    <xsl:text>
                  </xsl:text>
                  </t>
                </is>
              </xsl:for-each>
            </c>
          </row>
        </xsl:for-each>
        <row/>
        <row></row>
        <row r="{$Differences_per_Screen + 4}" spans="3:7" ht="18">
          <c r="C{$Differences_per_Screen + 4}" s="2" t="inlineStr">
            <is>
              <t>Differences per Component</t>
            </is>
          </c>
          <c r="E{$Differences_per_Screen + 4}" t="inlineStr">
            <is>
              <t>Screens:</t>
            </is>
          </c>
          <c r="F{$Differences_per_Screen + 4}" t="inlineStr">
            <is>
              <t>Tests:</t>
            </is>
          </c>
        </row>
        <xsl:for-each select="//stateDifference//component[not(descendant::component) and not(./@componentId = ./preceding::stateDifference//component/@componentId)]">
          <xsl:sort select="@componentId" />
          <xsl:variable name="component" select="."/>
          <row spans="3:7" outlineLevel="1">
            <c r="C" s="2" t="inlineStr">
              <is>
                <t>
                  <xsl:choose>
                    <xsl:when test="./attribute[@name='text']">
                      <xsl:text>Component "</xsl:text><xsl:value-of select="normalize-space(./attribute[@name='text'])"/>"
                    </xsl:when>
                    <xsl:when test="./expected/attribute[@name='text']">
                      <xsl:text>Component "</xsl:text><xsl:value-of select="normalize-space(./expected/attribute[@name='text'])"/>"
                    </xsl:when>
                    <xsl:when test="./actual/attribute[@name='text']">
                      <xsl:text>Component "</xsl:text><xsl:value-of select="normalize-space(./actual/attribute[@name='text'])"/>"
                    </xsl:when>
                    <xsl:when test="./expected/attribute[@name='path']">
                      <xsl:text>Path </xsl:text>
                      <xsl:value-of select="./expected/attribute[@name='path']"/>
                    </xsl:when>
                    <xsl:otherwise>
                      <xsl:text>Path </xsl:text>
                      <xsl:value-of select="./actual/attribute[@name='path']"/>
                    </xsl:otherwise>
                  </xsl:choose>
                </t>
              </is>
            </c>
            <c r="D" s="2" t="inlineStr">
              <is>
                <t>
                  <xsl:choose>
                    <xsl:when test="descendant::img[@type='expected']">
                      <!-- <xsl:value-of select="descendant::img[@type='expected']/@file" /> -->
                    </xsl:when>
                    <xsl:otherwise>
                      <xsl:for-each select="./attribute">
                        <xsl:value-of select="@name"/>=<xsl:value-of select="text()"/>
                      </xsl:for-each>
                    </xsl:otherwise>
                  </xsl:choose>
                </t>
              </is>
            </c>
            <c r="E" s="2" t="inlineStr">
              <xsl:for-each select="//window[(.//descendant::component/@componentId = $component/@componentId) and not(./@screenId = ./preceding::window/@screenId)]">
                <xsl:value-of select="@screen"/>
                <xsl:text>, </xsl:text>
              </xsl:for-each>
            </c>
            <c r="F" s="2" t="inlineStr">
              <xsl:for-each select="//test[.//descendant::component/@componentId = $component/@componentId]">
                <xsl:value-of select="@name"/>
              </xsl:for-each>
            </c>
          </row>
        </xsl:for-each>
        <row/>
        <row></row>
        <row spans="3:7" ht="18">
          <c r="C" s="2" t="inlineStr">
            <is>
              <t>Differences per Attribute</t>
            </is>
          </c>
          <c r="D" t="inlineStr">
            <is>
              <t>Actual</t>
            </is>
          </c>
          <c r="E" t="inlineStr">
            <is>
              <t>Expected</t>
            </is>
          </c>
          <c r="F" t="inlineStr">
            <is>
              <t>Components:</t>
            </is>
          </c>
          <c r="G" t="inlineStr">
            <is>
              <t>Tests:</t>
            </is>
          </c>
        </row>
        <xsl:for-each select="//attribute[@attributeId and not(@attributeId = ./preceding::attribute/@attributeId)]">
          <xsl:sort select="@name" />
          <xsl:variable name="attribute" select="."/>
          <row>
            <c r="C" s="2" t="inlineStr">
              <is>
                <t>
                  <xsl:value-of select="$attribute/@name" />
                </t>
              </is>
            </c>
            <c r="D" s="2" t="inlineStr">
              <is>
                <t>
                  <xsl:value-of select="$attribute/../../actual/attribute[@name=./@name]/text()" />
                </t>
              </is>
            </c>
            <c r="E" s="2" t="inlineStr">
              <is>
                <t>
                  <xsl:value-of select="$attribute/text()" />
                </t>
              </is>
            </c>
            <c r="F" s="2" t="inlineStr">
              <is>
                <t>
                  <xsl:for-each select="//stateDifference//component[not(descendant::component) 
                                        and not(./@componentId = preceding::stateDifference//component/@componentId)
                                        and ./expected/attribute[@name = $attribute/@name]/text() = $attribute/text()
                                        and ./actual/attribute[@name = $attribute/@name]/text() = $attribute/../../actual/attribute[@name = $attribute/@name]/text()]">
                    <xsl:choose>
                      <xsl:when test="descendant::img[@type='expected']">
                        <!-- <xsl:value-of select="descendant::img[@type='expected']/@file" /> -->
                        <xsl:text>, </xsl:text>
                      </xsl:when>
                      <xsl:otherwise>
                        <xsl:value-of select="./attribute[@name='text']"/> (<xsl:value-of select="./attribute[@name='type']"/>)<xsl:text>
                        </xsl:text>
                      </xsl:otherwise>
                    </xsl:choose>
                  </xsl:for-each>
                </t>
              </is>
            </c>
            <c r="G" s="2" t="inlineStr">
              <is>
                <t>
                  <xsl:for-each select="//test[.//descendant::expected/attribute[@name = $attribute/@name]/text() = $attribute/text() and .//descendant::actual/attribute[@name = $attribute/@name]/text() = $attribute/../../actual/attribute[@name = $attribute/@name]/text()]">
                    <xsl:value-of select="@name"/>
                    <xsl:text>
                    </xsl:text>
                  </xsl:for-each>
                </t>
              </is>
            </c>
          </row>
        </xsl:for-each>
        <row/>
        <xsl:for-each select="suite">
          <row>
            <c r="C" s="2" t="inlineStr">
              <is>
                <t>
                  <xsl:value-of select="@name" />
                </t>
              </is>
            </c>
            <c r="E" t="inlineStr">
              <is>
                <t>Tests:</t>
              </is>
            </c>
            <c r="F">
              <v>
                <xsl:value-of select="count(//test)" />
              </v>
            </c>
          </row>
          <row>
            <c r="E" t="inlineStr">
              <is>
                <t>Actions:</t>
              </is>
            </c>
            <c r="F">
              <v>
                <xsl:value-of select="count(//action)" />
              </v>
            </c>
          </row>
          <row>
            <c r="E" t="inlineStr">
              <is>
                <t>Duration:</t>
              </is>
            </c>
            <c r="F">
              <v>
                <xsl:value-of select="@duration" />
              </v>
            </c>
          </row>
          <row>
            <c r="E" t="inlineStr">
              <is>
                <t>Checked UI-Elements:</t>
              </is>
            </c>
            <c r="F">
              <v>
                <xsl:value-of select="count(//component)" />
              </v>
            </c>
          </row>
          <row>
            <c r="E" t="inlineStr">
              <is>
                <t>Covered Branches:</t>
              </is>
            </c>
            <c r="F" t="inlineStr">
              <is>
                <t>x</t>
              </is>
            </c>
          </row>
          <xsl:for-each select="test">
            <row>
              <c r="C" s="1" t="inlineStr">
                <is>
                  <t>
                    <xsl:value-of select="@name" />
                  </t>
                </is>
              </c>
            </row>
            <row>
              <c r="E" t="inlineStr">
                <is>
                  <t>Actions:</t>
                </is>
              </c>
              <c r="F">
                <v>
                  <xsl:value-of select="count(//action)" />
                </v>
              </c>
            </row>
            <row>
              <c r="E" t="inlineStr">
                <is>
                  <t>Duration:</t>
                </is>
              </c>
              <c r="F">
                <v>
                  <xsl:value-of select="@duration" />
                </v>
              </c>
            </row>
            <row>
              <c r="E" t="inlineStr">
                <is>
                  <t>Checked UI-Elements:</t>
                </is>
              </c>
              <c r="F">
                <v>
                  <xsl:value-of select="count(//component)" />
                </v>
              </c>
            </row>
            <row>
              <c r="E" t="inlineStr">
                <is>
                  <t>Covered Branches:</t>
                </is>
              </c>
              <c r="F" t="inlineStr">
                <is>
                  <t>x</t>
                </is>
              </c>
            </row>

            <row></row>
            <row></row>
            <!--Action-->
            <row>
              <c r="C" s="1" t="inlineStr">
                <is>
                  <t>Action</t>
                </is>
              </c>
              <c r="D" s="1" t="inlineStr">
                <is>
                  <t>Result</t>
                </is>
              </c>
              <c r="E" s="1" class="merge"/>
              <c r="F" s="1" t="inlineStr">
                <is>
                  <t>Duration</t>
                </is>
              </c>
            </row>
            <xsl:for-each select="action">
              <xsl:if test="state">
				<row>
				  <c r="B" s="11">
				    <v>
				      <xsl:value-of select="@actionNr" />
				    </v>
				  </c>
				  <c r="C" s="10" t="inlineStr">
				    <is>
				      <t>
				        <xsl:value-of select="@description" />
				        <xsl:if test="targetcomponent/img">
				          <!-- <xsl:value-of select="targetcomponent/img/@file" /> -->
				        </xsl:if>
				      </t>
				    </is>
				  </c>
				  <c r="D" s="10"/>
				  <c r="E" s="10"/>
				  <c r="F" s="10">
				    <v>
				      <xsl:value-of select="state/@duration" />
				    </v>
				  </c>
				</row>
               <!-- 
                <row>
                  <c r="B" s="7"/>
                  <c r="C" s="7"/>
                  <c r="D" s="12" t="inlineStr">
                    <is>
                      <t>
                        <xsl:value-of select="state/window/@title" />
                        <xsl:if test="state/window/img">
                         <xsl:value-of select="state/window/img/@file" />
                        </xsl:if>
                      </t>
                    </is>
                  </c>
                  <c r="E" s="13" class="merge"/>
                  <c r="F" s="8"/>
                </row> -->
              </xsl:if>
              <xsl:if test="stateDifference">
                <row>
                  <c r="B" s="8">
                    <v>
                      <xsl:value-of select="@actionNr" />
                    </v>
                  </c>
                  <c r="C" s="8" t="inlineStr">
                    <is>
                      <t>
                        <xsl:value-of select="@description" />
                        <xsl:if test="targetcomponent/img">
                          <!-- <xsl:value-of select="targetcomponent/img/@file" /> -->
                        </xsl:if>
                      </t>
                    </is>
                  </c>
                  <c r="D" s="8"/>
                  <c r="E" s="8"/>
                  <c r="F" s="8">
                    <v>
                      <xsl:value-of select="stateDifference/@duration" />
                    </v>
                  </c>
                </row>
                <!-- 
                <row>
                  <c r="B" s="8"/>
                  <c r="C" s="8"/>
                  <c r="D" s="8" t="inlineStr">
                    <is>
                      <t>
                        <xsl:value-of select="stateDifference/window/@title"/>
                        <xsl:if test="stateDifference/window/img[@type='actual']">
                          <xsl:value-of select="stateDifference/window/img[@type='actual']/@file" />
                        </xsl:if>
                      </t>
                    </is>
                  </c>
                  <c r="E" s="8" t="inlineStr">
                    <is>
                      <t>
                        <xsl:value-of select="stateDifference/window/@title"/>
                        <xsl:if test="stateDifference/window/img[@type='expected']">
                          <xsl:value-of select="stateDifference/window/img[@type='expected']/@file" />
                        </xsl:if>
                      </t>
                    </is>
                  </c>
                  <c r="F" s="8"/>
                </row>
                 -->
                <xsl:for-each select="descendant::component[not(descendant::component)]">
                  <row>
                    <c r="B" s="8"/>
                    <c r="C" s="8"/>
                    <c r="D" s="8" t="inlineStr">
                      <is>
                        <t>
                          <xsl:for-each select="descendant::expected/attribute">
                            <xsl:value-of select="./@name" />
                            <xsl:text> = </xsl:text>
                            <xsl:value-of select="normalize-space(./text())" />
                          </xsl:for-each>
                          <xsl:if test="descendant::img[@type='expected']">
                            <!-- <xsl:value-of select="descendant::img[@type='expected']/@file" /> -->
                          </xsl:if>
                        </t>
                      </is>
                    </c>
                    <c r="E" s="8" t="inlineStr">
                      <is>
                        <t>
                          <xsl:for-each select="descendant::actual/attribute">
                            <xsl:value-of select="./@name" />
                            <xsl:text> = </xsl:text>
                            <xsl:value-of select="normalize-space(./text())" />
                          </xsl:for-each>
                          <xsl:if test="descendant::img[@type='actual']">
                            <!-- <xsl:value-of select="descendant::img[@type='actual']/@file" /> -->
                          </xsl:if>
                        </t>
                      </is>
                    </c>
                    <c r="F" s="8"/>
                  </row>
                </xsl:for-each>
              </xsl:if>
            </xsl:for-each>
          </xsl:for-each>
        </xsl:for-each>
      </xsl:element>
      <mergeCells/>
      <pageMargins left="0.75" right="0.75" top="1" bottom="1" header="0.5" footer="0.5"/>
      <pageSetup paperSize="9" orientation="portrait" horizontalDpi="4294967292" verticalDpi="4294967292" r:id="rId1"/>
      <extLst>
        <ext uri="{64002731-A6B0-56B0-2670-7721B7C09600}" xmlns:mx="http://schemas.microsoft.com/office/mac/excel/2008/main">
          <mx:PLV Mode="0" OnePage="0" WScale="0"/>
        </ext>
      </extLst>
    </worksheet>
  </xsl:template>
  <xsl:template match="@* | node()">
    <xsl:copy>
      <xsl:apply-templates select="@* | node()"/>
    </xsl:copy>
  </xsl:template>
</xsl:stylesheet>
